/* DEMOVERSION: EASY SCRIPT v.0.0.1

Das Plugin ermglicht, eigene Konsolenbefehle fr bestimmte Funktionen zu erstellen
und den Rechtelevel fr diesen Konsolenbefehl festzulegen.
Die notwendigen Paramater sind vom ausfhrenden Befehl (s.u.) festgelegt.

Eingabe in die 'script.txt':
--------------------------------------------------------
- Konsolenbefehle werden mit einem ':' gekennzeichnet. Danach mit Leerzeichen und Zahl der Accesslevel.
- Der auszufhrende Befehl dieses Konsolenbefehls wird mit ';' gekennzeichnet.
- Die Beschreibung des Befehls kann so darunter eingegeben werden. (Am Besten erst die notwendigen Parameter und dann : Beschreibung)

Folgende ausfhrende Befehle stehen z.Z. zur Verfgung:
--------------------------------------------------------
BEFEHLE		Parameter in Konsole			Beschreibung
;HELP		<1>					zeigt alle registrierten Konsolenbefehle mit Beschreibung und Accesslevel
;SAY		<Nachricht>				einfache Chatnachricht an alle Spieler
;SAY_TO 	<Spieler> <Nachricht>			einfache Chatnachricht an einen Spieler (Adminname wird angezeigt!)
;TSAY		[Farbe opt.] <Nachricht>		(farbige) Nachricht links unten an alle
;CSAY		[Farbe opt.] <Nachricht>		(farbige) Nachricht in der Mitte an alle
;TSAY_TO	<Spieler> <Nachricht>			Nachricht an den Spieler (ohne Adminname, Farbe gelb)
;CSAY_TO	<Spieler> [Farbe opt.] <Nachricht>	(farbige) Nachricht in der Mitte an den Spieleran
;KILL		<Spieler>				ttet den Spieler
;SLAP		<Spieler>				slappt den Spieler

ANMERKUNG:
-----------
Als Konsolenbefehle auf KEINEN FALL HL-Commands bzw. Mod-Commands angeben.
Sonst funktionieren diese nmlich nicht mehr. Wenn ihr nmlich ein "say" als Konsolenbefehl nehmen
wrdet, dann knnte niemand mehr chatten, der nicht den angegebenen Accesslevel besitzt.
Zu Beachten gilt auch, dass gewisse Textlngen nicht berschritten werden drfen.
Das gilt besonders fr die Beschreibung des Konsolenbefehls und den Konsolenbefehl selbst!
Es wird zur Zeit noch nicht berprft, ob die Textlngen berschritten werden.

IN PLANUNG:
-----------
Falls es berhaupt Verwendung fr dieses Plugin gibt, dann kommen noch folgende Befehle dazu:
;KICK		<Spieler>
;BAN		<Spieler>
;BURY 		<Spieler>
;GLOW		<Farbe> <Spieler>
;SAY_CONSOLE	<Spieler>

In einer erweiterten Funktion wren dann auch mehrere ausfhrende Befehle mit einem Konsolenbefehl mglich.
Desweiteren wre dann in Planung ein ;ON_EVENT, um auf Kill-Event oder Injure Event zu reagieren.

*/

#include <core>
#include <string>
#include <admin>
#include <adminlib>

new AM_VERSION_STRING[] = "1.0";


new g_ScriptFile[MAX_TEXT_LENGTH]="addons/adminmod/config/easyscript/script.txt";

/*ON - Commands
#define MAX_EVENTS	12
new g_EventCommands[MAX_EVENTS][]=	{{"CONNECT","ENTER","DISCONNECT","KILL","INJURE",
					"TEAMATTACK","TEAMSELECT","PLANTING_BOMB","ROUND_START",
					"ROUND_END","RESTART_ROUND","HOSTAGE_KILL"}};
*/

/*EXEC - COMMANDS*/
#define MAX_COMMANDS	13
new g_ExecCommands[MAX_COMMANDS][]=	{{"HELP"},{"SAY"},{"SAY_TO"},{"TSAY"},{"CSAY"},
					{"TSAY_TO"},{"CSAY_TO"},{"KILL"},{"SLAP"},{"KICK"},{"BAN"},{"BURY"},{"GLOW"}};

					
/*Load Script*/
#define MAX_INPUT	50
new g_RegFunction[MAX_INPUT][MAX_COMMAND_LENGTH];
new g_AccessLevel[MAX_INPUT][MAX_NUMBER_LENGTH];
new g_Description[MAX_INPUT][MAX_DATA_LENGTH];
new g_DoCmd[MAX_INPUT][MAX_DATA_LENGTH];
new g_reg_function;


public plugin_init() {
	plugin_registerinfo("EASY PLUGIN WRITER","Ausfuehren eigener Funktionen ber SDAL-Text Script",AM_VERSION_STRING);
	/*plugin_registercmd("sscript_connect", "sscript_connect", ACCESS_CONSOLE, "");
	plugin_registercmd("sscript_disconnect", "sscript_disconnect", ACCESS_CONSOLE, "");
	plugin_registercmd("sscript_suicide", "sscript_suicide", ACCESS_CONSOLE, "");
	plugin_registercmd("sscript_kill", "sscript_kill", ACCESS_CONSOLE, "");
	plugin_registercmd("sscript_injure", "sscript_injure", ACCESS_CONSOLE, "");
	plugin_registercmd("sscript_pction", "sscript_pction", ACCESS_CONSOLE, "");
	plugin_registercmd("sscript_taction", "sscript_taction", ACCESS_CONSOLE, "");
	plugin_registercmd("sscript_world", "sscript_world", ACCESS_CONSOLE, "");
	exec( "logd_reg 51 admin_command sscript_connect" );
	exec( "logd_reg 52 admin_command sscript_disconnect" );
	exec( "logd_reg 53 admin_command sscript_suicide" );
	exec( "logd_reg 57 admin_command sscript_kill" );
	exec( "logd_reg 58 admin_command sscript_injure" );
	exec( "logd_reg 60 admin_command sscript_paction" ); 
	exec( "logd_reg 61 admin_command sscript_taction" );
	exec( "logd_reg 62 admin_command sscript_world");*/
	read_file();
	return PLUGIN_CONTINUE;
}

read_file(){
	new Data[MAX_DATA_LENGTH];
	new i;
	new iLine;
	iLine=filesize(g_ScriptFile);
	for(i=0;i<=iLine;i++){
		readfile(g_ScriptFile,Data,i,MAX_DATA_LENGTH);
		if(strncmp(Data,":",1)==0){
			g_reg_function++;
			strsep(Data[1]," ",g_RegFunction[g_reg_function],MAX_COMMAND_LENGTH,g_AccessLevel[g_reg_function],MAX_NUMBER_LENGTH);
		}if(strncmp(Data,";",1)==0){
			strcpy(g_DoCmd[g_reg_function],Data[1],MAX_DATA_LENGTH);
		}else{
			strcpy(g_Description[g_reg_function],Data,MAX_DATA_LENGTH);
		}
	}
}
	
public plugin_command(HLCommand, HLData, HLUserName, UserIndex){
	new Command[MAX_DATA_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new authlevel;
	new i;
	new j;
	
	convert_string(HLCommand, Command, MAX_COMMAND_LENGTH);
	convert_string(HLData, Data, MAX_DATA_LENGTH);
	convert_string(HLUserName, User, MAX_NAME_LENGTH);
	
	for(i=1;i<=g_reg_function;i++){
		if(strcmp(Command,g_RegFunction[i])==0){
			authlevel=strtonum(g_AccessLevel[i]);
			if(check_auth(authlevel)){
				if(check_length(Data)){
					for(j=0;j<=MAX_COMMANDS;j++){
						if(strcmp(g_ExecCommands[j],g_DoCmd[i])==0){
							switch(j){
								case 0: show_help();
								case 1: say_all(Data);
								case 2: say_to(Data,User);
								case 3: tsay(Data);
								case 4: csay(Data);
								case 5: tsay_to(Data);
								case 6: csay_to(Data);
								case 7: kill_p(Data);
								case 8: slap_p(Data);
								/*case 9: kick_p(Data);
								case 10: ban_p(Data);
								case 11: bury_p(Data);
								case 12: glow_p(Data);*/
							}
						}
					}
				}
			}else{
				selfmessage("[SDAL-SCRIPT] You are not allowed to execute this command!");
			}
			return PLUGIN_HANDLED;
		}
	}
	return PLUGIN_CONTINUE;
}

show_help(){
	new Text[MAX_TEXT_LENGTH];
	new i;
	selfmessage("*************************");
	selfmessage("* SDAL-EASY-SCRIPT");
	selfmessage("* (Bitte Konsolenfenster vergroeern!)");
	selfmessage("*************************");
	selfmessage("* Registrierte Funktionen:(Funktion, Beschreibung, (Rechtelevel)");
	for(i=1;i<=g_reg_function;i++){
		snprintf(Text,MAX_TEXT_LENGTH,"* %s %s (%s)",g_RegFunction[i],g_Description[i],g_AccessLevel[i]);
		selfmessage(Text);
		strinit(Text);
	}
	return PLUGIN_HANDLED;
}

say_all(Data[]){
	say(Data);
}

say_to(Data[],User[]){
	new Text[MAX_TEXT_LENGTH];
	new Player[MAX_NAME_LENGTH];
	strbreak(Data,Player,Text,MAX_DATA_LENGTH);
	if(player_available(Player)){
		snprintf(Text,MAX_TEXT_LENGTH,"%s :%s",User,Text);
		messageex(Player,Text,print_chat);
	}
}

tsay(Data[]){
	new Text[MAX_TEXT_LENGTH];
	new iRed;
	new iGreen;
	new iBlue;
	get_color(Data,Text,iRed,iGreen,iBlue);
	typesay(Text,12,iRed,iGreen,iBlue);
}

csay(Data[]){
	new Text[MAX_TEXT_LENGTH];
	new iRed;
	new iGreen;
	new iBlue;
	get_color(Data,Text,iRed,iGreen,iBlue);
	centersay(Text,12,iRed,iGreen,iBlue);
}

tsay_to(Data[]){
	new Text[MAX_TEXT_LENGTH];
	new Player[MAX_NAME_LENGTH];
	strbreak(Data,Player,Text,MAX_DATA_LENGTH);
	if(player_available(Player)){
		messageex(Player,Text,print_tty);
	}
}

csay_to(Data[]){
	new Text[MAX_TEXT_LENGTH];
	new Player[MAX_NAME_LENGTH];
	new iRed;
	new iGreen;
	new iBlue;
	strbreak(Data,Player,Text,MAX_DATA_LENGTH);
	if(player_available(Player)){
		get_color(Text,Text,iRed,iGreen,iBlue);
		centersayex(Player,Text,12,iRed,iGreen,iBlue);
	}
	
}

kill_p(Player[]){
	if(player_available(Player)){
		if(!is_immunity(Player)){
			slay(Player);
		}
	}
}

slap_p(Player[]){
	if(player_available(Player)){
		if(!is_immunity(Player)){
			slap(Player);
		}
	}
}
		
	

/*HELPER-FUNCTIONS*/
check_length(Data[]){
	if(strlen(Data)!=0){
		return 1;
	}else{
		selfmessage("[SDAL-SCRIPT] You must enter something!");
	}
	return 0;
}

get_color(Data[],Text[],&iRed,&iGreen,&iBlue){
	new Msg[MAX_TEXT_LENGTH];
	new Color[MAX_NAME_LENGTH];
	strbreak(Data,Color,Msg,MAX_DATA_LENGTH);
	if (streq(Color,"red")==1) {
		iRed=250;
		iGreen=10;
		iBlue=10;
	} else if ( streq(Color, "blue")==1) {
		iRed=10;
		iGreen=10;
		iBlue=250;
	} else if ( streq(Color, "green")==1) {
		iRed=10;
		iGreen=250;
		iBlue=10;
	} else if ( streq(Color, "white")==1) {
		iRed=250;
		iGreen=250;
		iBlue=250;
	} else if ( streq(Color, "yellow")==1) {
		iRed=250;
		iGreen=250;
		iBlue=10;
	} else if ( streq(Color, "purple")==1) {
		iRed=250;
		iGreen=10;
		iBlue=250;
	} else if ( streq(Color, "random")==1) {
		iRed=random(100);
		iGreen=random(100);
		iBlue=random(100);
	} 
	if(iRed!=0){
		strcpy(Text,Msg,MAX_TEXT_LENGTH);
	}else{
		iRed=220;
		iGreen=220;
		iBlue=220;
		strcpy(Text,Data,MAX_TEXT_LENGTH);
	}
}

player_available(Player[]){
	if (check_user(Player)){
		get_username(Player,Player,MAX_NAME_LENGTH);
		return 1;
	}else{
		selfmessage("[SDAL-SCRIPT] Player is not available!");
	}
	return 0;
}

is_immunity(Player[]){
	new Text[MAX_TEXT_LENGTH];
	if(check_immunity(Player)) {
		snprintf(Text, MAX_TEXT_LENGTH, "[SDAL-SCRIPT] LOL. '%s' is immune, you silly bear.", Player);
		selfmessage(Text);
		return 1;
	}
	return 0;
}